#ifndef DRAW_H
#define DRAW_H

#include <gccore.h>
#include "GRRLIB/GRRLIB.h"
#include "fonts/f8r.h"

#include <iostream>
#include <sstream>
using namespace std;

#define C_BLACK 0xFF000000
#define C_BLACK50 0x7F000000
#define C_WHITE 0xFFFFFFFF
#define C_GREEN 0xFF00FF00
#define C_BLUE 0xFF0090FF
#define C_GREY 0xFFAAAAAA
#define C_RED 0xFFFF4343


/*
	This is where we draw things on the screen
*/

class Draw{
	public:
		static Draw* getInstance();
		~Draw();
		
		void setColor(u32 color);
		void drawText(int line,string text);
		void drawFreeText(int x, int y,string text,int size = 1);
		void drawPixel(int x, int y);
		void drawLine(int x1, int y1, int x2, int y2);
		void drawBox(int x1, int y1, int w, int h);
		void fillBox(int x1, int y1, int w, int h);
		void fill50Box(int x, int y, int w, int h);
		void drawSliderBox(int x, int y, int w, int h, int sliderpos);
		void fillScreen();
		u8* getTextureFromBuffer(const unsigned char* buffer);
		void drawTexture(int x, int y, int w, int h, u8* texture, bool frame = false, float rotation = 0, float scalex = 1, float scaley = 1, float alpha = 255);
		void render();
		
		string intToString(int integer);
		string doubleToString(double doubleval);
		string boolToString(bool boolean);
	
	private:
		Draw();
		static Draw* instance;
		u32 drawColor;
		u8* drawFont;
};

#endif
