#include "WiiCmd.h"

WiiCmd* WiiCmd::instance = 0;

WiiCmd* WiiCmd::getInstance(){
	if(!instance){
		instance = new WiiCmd();
	}
	return instance;
}

/*void* WiiCmd::getFB(){
	return framebuffer;
}*/

/*GXRModeObj* WiiCmd::getRmode(){
	return rmode;
}*/

ir_t WiiCmd::getIr(){
	return ir;
}

vec3w_t WiiCmd::getAccel(){
	return accel;
}

bool WiiCmd::wiimoteConnected(int wiimote){
	
	u32 type;
	int res = WPAD_Probe(wiimote, &type);
	if(res == WPAD_ERR_NONE){
		return true;
	}
	
	return false;
}

bool WiiCmd::isDown(int button){
	if ( btnDown & button ){
		return true;
	}
	return false;
}

bool WiiCmd::isHeld(int button){
	if ( btnHeld & button ){
		return true;
	}
	return false;
}

bool WiiCmd::isUp(int button){
	if ( btnUp & button ){
		return true;
	}
	return false;
}

void WiiCmd::update(){
	WPAD_ScanPads();
	btnDown = WPAD_ButtonsDown(0);
	btnHeld = WPAD_ButtonsHeld(0);
	btnUp = WPAD_ButtonsUp(0);
	WPAD_IR(0,&ir);
	WPAD_Accel(0,&accel);
}

//void WiiCmd::clearFB(){
//	VIDEO_ClearFrameBuffer(rmode,framebuffer,COLOR_BLACK);
//}

void WiiCmd::waitVSync(){
	VIDEO_WaitVSync();
}

WiiCmd::WiiCmd(){

	//framebuffer = NULL;
	//rmode = NULL;

	VIDEO_Init();
	WPAD_Init();
	fatInitDefault();
	
	//WPAD_SetVRes(0, 640, 480); //Wiimote ir resolution
	WPAD_SetDataFormat(WPAD_CHAN_0, WPAD_FMT_BTNS_ACC); //Use IR WPAD_FMT_BTNS_IR_ACC

	/*rmode = VIDEO_GetPreferredMode(NULL);
	framebuffer = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(framebuffer,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth * VI_DISPLAY_PIX_SZ);
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(framebuffer);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode & VI_NON_INTERLACE){
		VIDEO_WaitVSync();
	}*/
	
	GRRLIB_InitVideo();
	GRRLIB_Start();
}

WiiCmd::~WiiCmd(){
}
