#ifndef WIICMD_H
#define WIICMD_H

#include <gccore.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include "GRRLIB/GRRLIB.h"

/*
	This class does all the Wii related communication and initialisation.
	Implemented as a singleton to prevent a double init.
*/

class WiiCmd{

	public:
		static WiiCmd* getInstance();
		~WiiCmd();
		
		//void* getFB();
		//GXRModeObj* getRmode();
		ir_t getIr();
		vec3w_t getAccel();
		
		void update(); //Needs to be called each frame to read buttons & co.
		void waitVSync();
		//void clearFB();
		
		bool wiimoteConnected(int wiimote);
		
		bool isDown(int button);
		bool isHeld(int button);
		bool isUp(int button);
		
	
	private:
		WiiCmd();
		//void* framebuffer;
		//GXRModeObj* rmode;
		static WiiCmd* instance;
		
		//Wiimote states
		u32 btnDown;
		u32 btnHeld;
		u32 btnUp;
		ir_t ir;
		vec3w_t accel;
		
};


#endif
